--- eliloconfig.orig	2017-01-15 16:48:53.546856797 +0100
+++ eliloconfig	2017-01-16 22:47:11.676200987 +0100
@@ -90,12 +90,16 @@
 fi
 
 # Figure out the device and partition number of the ESP:
+DEVLEN=8
+PARTLEN=9
 if mount | grep vfat | grep -wq /boot/efi ; then
-  EFI_DEVICE=$(mount | grep vfat | grep -w /boot/efi | cut -b 1-8)
-  EFI_PARTITION=$(mount | grep vfat | grep -w /boot/efi | cut -f 1 -d ' ' | cut -b 9- | tr -d [a-z])
+  mount | grep vfat | grep -w /boot/efi|grep -q nvme && DEVLEN=12 && PARTLEN=14
+  EFI_DEVICE=$(mount | grep vfat | grep -w /boot/efi | cut -b 1-${DEVLEN})
+  EFI_PARTITION=$(mount | grep vfat | grep -w /boot/efi | cut -f 1 -d ' ' | cut -b ${PARTLEN}- | tr -d [a-z])
 else
-  EFI_DEVICE=$(mount | grep vfat | grep -w /mnt/boot/efi | cut -b 1-8)
-  EFI_PARTITION=$(mount | grep vfat | grep -w /mnt/boot/efi | cut -f 1 -d ' ' | cut -b 9- | tr -d [a-z])
+  mount | grep vfat | grep -w /mnt/boot/efi|grep -q nvme && DEVLEN=12 && PARTLEN=14
+  EFI_DEVICE=$(mount | grep vfat | grep -w /mnt/boot/efi | cut -b 1-${DEVLEN})
+  EFI_PARTITION=$(mount | grep vfat | grep -w /mnt/boot/efi | cut -f 1 -d ' ' | cut -b ${PARTLEN}- | tr -d [a-z])
 fi
 
 # There better be a kernel:
